<?php
/**
 * Eye4fraud Integration
 *
 * @package  Eye4fraud
 *
 */

namespace Eye4fraud\Base;

use Eye4fraud\Database\InsertTable;

class Activate {
	public static function activate() {
		if ( Required::is_woocommerce_active() ) {
			InsertTable::create_eye4fraud_status_table();
			add_option( 'redirect_page', true );
			flush_rewrite_rules();
		} else {
			wp_die( 'Eye4fraud plugin is deactivated as Woocommerce needs to be enabled' );
		}
	}
}
