<?php

namespace Eye4fraud\Log;

use Eye4fraud\Services\OrderDataProvider;

use Eye4fraud\Base\BaseController;

class Log {

	public static function debug_log_content( $e ) {
		$base_controller = new BaseController();

		if ( OrderDataProvider::eye4fraud_get_option( 'wc_settings_' . $base_controller->domain . '_debug_enabled' ) == 'yes' ) {
			$upload_dir = wp_upload_dir();

			$line = gmdate( 'Y-m-d H:i:s' ) . ' : ';
			if ( !is_dir( $upload_dir['basedir'] . '/eye4fraud_logs' ) ) {
				mkdir( $upload_dir['basedir'] . '/eye4fraud_logs', 0777, true );
			}
			$file_pointer = $upload_dir['basedir'] . '/eye4fraud_logs/eye4fraud-' . gmdate( 'Y-m-d' ) . '.log';
			if ( is_array( $e ) ) {
				$e = print_r( $e, true );
			} else if ( is_object( $e ) ) {
				$e = var_dump( $e );
			}
			$line .= $e;
			$line .= PHP_EOL;
			file_put_contents( $file_pointer, $line, FILE_APPEND );
			self::delete_log();
		}
	}


	public static function delete_log() {
		$days = 1;
		$upload_dir = wp_upload_dir();
		$path = $upload_dir['basedir'] . '/eye4fraud_logs';
		$handle = opendir( $path );
		if ( $handle ) {
			// Loop through the directory
			while ( false !== ( $file = readdir( $handle ) ) ) {
				// Check the file we're doing is actually a file
				if ( is_file( $path . $file ) ) {
					// Check if the file is older than X days old
					if ( filemtime( $path . $file ) < ( time() - ( $days * 24 * 60 * 60 ) ) ) {
						// Do the deletion
						unlink( $path . $file );
					}
				}
			}
		}
	}
}
