<script>
	var BaseUrl = '<?php echo esc_html( $urlPath ); ?>';
</script>

<main class="main">


	<div class="section bc-step-0">
		<div class="container">
			<div class="content-section border-top shadow">
				<div class="logo-section">
					<div class="logo-section-item">
						<img src="<?php echo esc_html( $urlPath ); ?>/assets/images/img1.svg" alt="image" width="113">
					</div>
					<div class="logo-section-divider">
						<img src="<?php echo esc_html( $urlPath ); ?>/assets/images/plus.png" alt="image" width="10">
					</div>
					<div class="logo-section-item fix-top">
						<img src="<?php echo esc_html( $urlPath ); ?>/assets/images/woolo.png" alt="image" width="50"
							 style="margin-top: 11px;">
					</div>
				</div>
				<div class="row-title">
					<h1>Last step: Create or link your Eye4Fraud account to start accepting orders.</h1>
					<p>Your Eye4Fraud app was successfully installed on your Woocommerce store. Now you just need to
						link your existing
						Eye4Fraud account or create a new one and you’re all set!</p>
				</div>
				<div class="section-form">
					<a href="#" class="btn bc-step-0-create"><img
								src="<?php echo esc_html( $urlPath ); ?>/assets/images/plus.png" alt="image" width="12">Create
						a new account</a>
					<span>Or</span>
					<a href="#" class="btn bc-step-0-link"><img
								src="<?php echo esc_html( $urlPath ); ?>/assets/images/Chain.png" alt="image"
								width="13">Link
						an existing account</a>
				</div>
			</div>
		</div>
	</div>


	<!-- FORM -->
	<div class="section bc-step-1" style="display: none;">
		<div class="container">
			<div class="main-section pb-1 border-top shadow">
				<div class="row-title mb-1">
					<h1>Create an account</h1>
					<p>Already have an account? <a class="bc1-link" href="#">Log in instead.</a></p>
				</div>
				<div class="section-form">
					<form action="#" class="needs-validation" novalidate>
						<div class="field-items">
							<div class="h6">1. Company information</div>
							<span class="field-item input input--yoshiko">
								<input class="input__field input__field--yoshiko" type="text" id="input-1"
									name="company-name">
								<label class="input__label input__label--yoshiko" for="input-1">
									<span class="input__label-content input__label-content--yoshiko"
										  data-content="Company name">Company name</span>
								</label>
							</span>

							<span class="field-item input input--yoshiko">
								<input class="input__field input__field--yoshiko" type="text" id="input-2"
									name="company-website">
								<label class="input__label input__label--yoshiko" for="input-2">
									<span class="input__label-content input__label-content--yoshiko"
										  data-content="Company website">Company website</span>
								</label>
							</span>
						</div>

						<div class="field-items">
							<div class="h6">2. Contact information</div>
							<span class="field-item input input--yoshiko">
								<input class="input__field input__field--yoshiko" type="email" id="input-4"
									name="email-address">
								<label class="input__label input__label--yoshiko" for="input-4">
									<span class="input__label-content input__label-content--yoshiko"
										  data-content="Email address">Email address</span>
								</label>
							</span>
						</div>

						<div class="field-items">
							<div class="h6">3. Company Address</div>
							<span class="field-item select-box">
								<select name="select-country">
									<option value="">Select country</option>
									<!--											<option value="Reunion">Reunion</option>-->
									<!--											<option value="Tunisia">Tunisia</option>-->
									<!--											<option value="United-Arab-Emirates">United Arab Emirates</option>-->
									<!--											<option value="United-Kingdom">United Kingdom</option>-->
									<!--											<option value="United-States-of-America">United States of America</option>-->
									<!--											<option value="Reunion">Reunion</option>-->
									<!--											<option value="Tunisia">Tunisia</option>-->
									<!--											<option value="United-Arab-Emirates">United Arab Emirates</option>-->
									<!--											<option value="United-Kingdom">United Kingdom</option>-->
									<option value="US">United States of America</option>
								</select>
							</span>

							<span class="field-item input input--yoshiko">
								<input class="input__field input__field--yoshiko" type="text" id="input-6"
									name="address-line-1">
								<label class="input__label input__label--yoshiko" for="input-6">
									<span class="input__label-content input__label-content--yoshiko"
										  data-content="Address line 1">Address line 1</span>
								</label>
							</span>

							<div class="holder-fields">
								<span class="field-item input input--yoshiko w-68">
									<input class="input__field input__field--yoshiko" type="text" id="input-8"
										name="city">
									<label class="input__label input__label--yoshiko" for="input-8">
										<span class="input__label-content input__label-content--yoshiko"
											  data-content="City">City</span>
									</label>
								</span>
								<span class="field-item input input--yoshiko w-32">
									<input class="input__field input__field--yoshiko" type="text" id="input-9"
										name="zip-code">
									<label class="input__label input__label--yoshiko" for="input-9">
										<span class="input__label-content input__label-content--yoshiko"
											  data-content="ZIP code">ZIP code</span>
									</label>
								</span>
							</div>

							<span class="field-item select-box">

<select name="select-state" data-select2-id="4" tabindex="-1" class="select2-hidden-accessible" aria-hidden="true">
	<option value="Alaska" data-select2-id="6">Alaska</option>
	<option value="Alabama" data-select2-id="13">Alabama</option>
	<option value="Arkansas" data-select2-id="14">Arkansas</option>
	<option value="Arizona" data-select2-id="15">Arizona</option>
	<option value="California" data-select2-id="16">California</option>
	<option value="Colorado" data-select2-id="17">Colorado</option>
	<option value="Connecticut" data-select2-id="18">Connecticut</option>
	<option value="Delaware" data-select2-id="19">Delaware</option>
	<option value="District of Columbia" data-select2-id="20">District of Columbia</option>
	<option value="Florida" data-select2-id="21">Florida</option>
	<option value="Georgia" data-select2-id="22">Georgia</option>
	<option value="Hawaii" data-select2-id="23">Hawaii</option>
	<option value="Iowa" data-select2-id="24">Iowa</option>
	<option value="Idaho" data-select2-id="25">Idaho</option>
	<option value="Illinois" data-select2-id="26">Illinois</option>
	<option value="Indiana" data-select2-id="27">Indiana</option>
	<option value="Kansas" data-select2-id="28">Kansas</option>
	<option value="Kentucky" data-select2-id="29">Kentucky</option>
	<option value="Louisiana" data-select2-id="30">Louisiana</option>
	<option value="Massachusetts" data-select2-id="31">Massachusetts</option>
	<option value="Maine" data-select2-id="32">Maine</option>
	<option value="Maryland" data-select2-id="33">Maryland</option>
	<option value="Michigan" data-select2-id="34">Michigan</option>
	<option value="Minnesota" data-select2-id="35">Minnesota</option>
	<option value="Missouri" data-select2-id="36">Missouri</option>
	<option value="Mississippi" data-select2-id="37">Mississippi</option>
	<option value="Montana" data-select2-id="38">Montana</option>
	<option value="North Carolina" data-select2-id="39">North Carolina</option>
	<option value="North Dakota" data-select2-id="40">North Dakota</option>
	<option value="Nebraska" data-select2-id="41">Nebraska</option>
	<option value="New Hampshire" data-select2-id="42">New Hampshire</option>
	<option value="New Jersey" data-select2-id="43">New Jersey</option>
	<option value="New Mexico" data-select2-id="44">New Mexico</option>
	<option value="Nevada" data-select2-id="45">Nevada</option>
	<option value="New York" data-select2-id="46">New York</option>
	<option value="Ohio" data-select2-id="47">Ohio</option>
	<option value="Oklahoma" data-select2-id="48">Oklahoma</option>
	<option value="Oregon" data-select2-id="49">Oregon</option>
	<option value="Pennsylvania" data-select2-id="50">Pennsylvania</option>
	<option value="Rhode Island" data-select2-id="51">Rhode Island</option>
	<option value="South Carolina" data-select2-id="52">South Carolina</option>
	<option value="South Dakota" data-select2-id="53">South Dakota</option>
	<option value="Tennessee" data-select2-id="54">Tennessee</option>
	<option value="Texas" data-select2-id="55">Texas</option>
	<option value="Utah" data-select2-id="56">Utah</option>
	<option value="Vermont" data-select2-id="57">Vermont</option>
	<option value="Virginia" data-select2-id="58">Virginia</option>
	<option value="Washington" data-select2-id="59">Washington</option>
	<option value="Wisconsin" data-select2-id="60">Wisconsin</option>
	<option value="West Virginia" data-select2-id="61">West Virginia</option>
	<option value="Wyoming" data-select2-id="62">Wyoming</option>
	<option value="Armed Forces Americas (except Canada)"
			data-select2-id="63">Armed Forces Americas (except Canada)</option>
	<option value="Armed Forces Africa,Canada,Europe,Middle East" data-select2-id="64">Armed Forces Africa,Canada,Europe,Middle East</option>
	<option value="Armed Forces Pacific" data-select2-id="65">Armed Forces Pacific</option>
	<option value="American Samoa" data-select2-id="66">American Samoa</option>
	<option value="Federated States of Micronesia" data-select2-id="67">Federated States of Micronesia</option>
	<option value="Guam" data-select2-id="68">Guam</option>
	<option value="Marshall Islands" data-select2-id="69">Marshall Islands</option>
	<option value="Northern Mariana Islands" data-select2-id="70">Northern Mariana Islands</option>
	<option value="Palau" data-select2-id="71">Palau</option>
	<option value="Puerto Rico" data-select2-id="72">Puerto Rico</option>
	<option value="Virgin Islands" data-select2-id="73">Virgin Islands</option>
</select>
									</span>
						</div>
						<div class="field-items-submit">
							<button type="button" class="bc-step-1-submit">
								Next
							</button>
						</div>
					</form>
					<div class="form-descr">
						<p>By signing up, you agree to Eye4Fraud’s <a href="#">Terms and Conditions</a> and <a
									target="_blank" href="https://eye4fraud.com/privacy">Privacy Policy.</a></p>
					</div>
				</div>
			</div>
		</div>
	</div>


	<!-- PROFILE -->
	<div class="section bc-step-2 di" style="display: none;">
		<div class="container">
			<div class="main-section border-top shadow">
				<div class="row-title" style="margin-bottom: 0;">
					<h1>Your profile</h1>
					<p>View and edit your profile here.</p>
				</div>

				<div id="error_message" style="font-weight: bold; color: red; padding: 20px 0;"></div>

				<div class="section-form">
					<form action="#" novalidate id="bc-step-2">
						<div class="field-items">
							<span class="field-item input input--yoshiko">
								<input class="input__field input__field--yoshiko required" type="email" id="input-21"
									name="p-email-address">
								<label class="input__label input__label--yoshiko" for="input-21">
									<span class="input__label-content input__label-content--yoshiko"
										  data-content="Email address">Email address</span>
								</label>
							</span>

							<div class="holder-fields">
								<span class="field-item input input--yoshiko w-50">
									<input class="input__field input__field--yoshiko required" type="text" id="input-31"
										name="first-name">
									<label class="input__label input__label--yoshiko" for="input-31">
										<span class="input__label-content input__label-content--yoshiko"
											  data-content="First name">First name</span>
									</label>
								</span>
								<span class="field-item input input--yoshiko w-50">
									<input class="input__field input__field--yoshiko required" type="text" id="input-41"
										name="last-name">
									<label class="input__label input__label--yoshiko" for="input-41">
										<span class="input__label-content input__label-content--yoshiko"
											  data-content="Last name">Last name</span>
									</label>
								</span>
							</div>

							<div class="holder-fields">
								<span class="field-item input input--yoshiko w-76">
									<input class="input__field input__field--yoshiko" type="number" id="input-51"
										name="p-phone-number">
									<label class="input__label input__label--yoshiko" for="input-51">
										<span class="input__label-content input__label-content--yoshiko"
											  data-content="Phone number">Phone number</span>
									</label>
								</span>
							</div>
						</div>

						<div class="field-items-submit">
							<button type="submit" class="bc-step-2-back">
								Back
							</button>
							<button type="submit" class="bc-step-2-submit" data-url="">
								Submit
							</button>
						</div>

						<input type="hidden" name="register_new" value="1"/>
					</form>
				</div>
			</div>
		</div>
	</div>


	<!-- LINK ACCOUNT -->
	<div id="page_message" class="login_message page_mess_animate page_mess_error" style="display: none;">Api Key or Api
		Login is not valid.
	</div>

	<div class="section bc-step-3 di" style="display: none;">
		<div class="container">
			<form action="#" method="post">
				<div class="main-section border-top shadow">
					<div class="row-title">
						<h1>Link your account</h1>
						<p>Don’t have an account? <a class="bc3-link" href="#">Create one here.</a></p>
					</div>

					<div id="error_message2" style="font-weight: bold; color: red; margin: -20px 0;"></div>

					<div class="section-form">
						<div class="field-items">
							<span class="field-item input input--yoshiko">
								<input class="input__field input__field--yoshiko form-control required" type="text"
									id="input-1" name="apiLogin" value=''>
								<label class="input__label input__label--yoshiko" for="input-1">
									<span class="input__label-content input__label-content--yoshiko"
										  data-content="Api Login">Api Login</span>
								</label>
							</span>

							<span class="field-item input input--yoshiko">
								<input class="input__field input__field--yoshiko form-control required" type="text"
									id="input-2" name="apiKey" value=''>
								<label class="input__label input__label--yoshiko" for="input-2">
									<span class="input__label-content input__label-content--yoshiko"
										  data-content="Api Key">Api Key</span>
								</label>
							</span>
						</div>

						<div class="field-items-submit">
							<button type="button" class="loginsubmit" data-url="">
								SAVE
							</button>
						</div>

						<input type="hidden" name="register_new" value="0"/>
					</div>
				</div>
			</form>
		</div>
	</div>


	<!-- FINAL -->
	<div class="section bc-step-4" style="display: none;">
		<div class="container">
			<div class="main-section border-top shadow">
				<div class="row-title mb-2">
					<h1>You’re all set!</h1>
					<p>You’re now ready to start accepting orders with Eye4Fraud.</p>
				</div>
				<a id="allset" href="javascript:void(0)" class="btn btn-red">
					Go to your dashboard
				</a>
			</div>
		</div>
	</div>


</main>
