<?php
/**
 *
 * Eye4fraud Integration
 *
 * @package  Eye4fraud
 *
 */

namespace Eye4fraud\Base;

class Enqueue extends BaseController {
	public function register() {
		add_action( 'admin_enqueue_scripts', array( $this, 'enqueue' ) );
	}

	public function enqueue() {
		// enqueue all our scripts
		wp_enqueue_script( 'eye4fraud_script', $this->plugin_url . 'assets/e4f-ajax-script.js', '1.0.0', true );
		wp_localize_script( 'eye4fraud_script', 'eye4fraud_script_ajax_object',
			array(
				'e4f_ajaxurl' => admin_url( 'admin-ajax.php' )
			)
		);
	}
}
