<?php

namespace Eye4fraud\Database;

class InsertTable {

	const TABLE_EYE4FRAUD = 'eye4fraud_status';

	/**
	 *
	 * Create eye4fraud_status table
	 *
	 * Create eye4fraud_status_table on activation
	 *
	 */
	public static function create_eye4fraud_status_table() {
		global $wpdb;

		$table_name = $wpdb->prefix . self::TABLE_EYE4FRAUD;
		$wpdb_collate = $wpdb->collate;

		require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );

		$sql = "
            CREATE TABLE IF NOT EXISTS {$table_name} (
                id int(11) NOT NULL AUTO_INCREMENT,
                order_id int(4) NOT NULL,
                status VARCHAR(200) NOT NULL,
                createdOn DATETIME,
            PRIMARY KEY (id)
            ); COLLATE {$wpdb_collate}
        ";

		dbDelta( $sql );
	}

}
